INLINE void CLAMP_NC_NDOS_NDOT(INT32* S, INT32* T, INT32* SFRAC, INT32* TFRAC, INT32 maxs, INT32 maxt, TILE* tex_tile);
INLINE void CLAMP_NC_NDOS_DOT(INT32* S, INT32* T, INT32* SFRAC, INT32* TFRAC, INT32 maxs, INT32 maxt, TILE* tex_tile);
INLINE void CLAMP_NC_DOS_NDOT(INT32* S, INT32* T, INT32* SFRAC, INT32* TFRAC, INT32 maxs, INT32 maxt, TILE* tex_tile);
INLINE void CLAMP_NC_DOS_DOT(INT32* S, INT32* T, INT32* SFRAC, INT32* TFRAC, INT32 maxs, INT32 maxt, TILE* tex_tile);

INLINE void CLAMP_LIGHT_NC_NDOS_NDOT(INT32* S, INT32* T, INT32 maxs, INT32 maxt, TILE* tex_tile);
INLINE void CLAMP_LIGHT_NC_NDOS_DOT(INT32* S, INT32* T, INT32 maxs, INT32 maxt, TILE* tex_tile);
INLINE void CLAMP_LIGHT_NC_DOS_NDOT(INT32* S, INT32* T, INT32 maxs, INT32 maxt, TILE* tex_tile);
INLINE void CLAMP_LIGHT_NC_DOS_DOT(INT32* S, INT32* T, INT32 maxs, INT32 maxt, TILE* tex_tile);

INLINE void CLAMP_QUICK_NC_NDOS_NDOT(INT32* S, INT32* T, INT32 maxs, INT32 maxt, int num);
INLINE void CLAMP_QUICK_NC_NDOS_DOT(INT32* S, INT32* T, INT32 maxs, INT32 maxt, int num);
INLINE void CLAMP_QUICK_NC_DOS_NDOT(INT32* S, INT32* T, INT32 maxs, INT32 maxt, int num);
INLINE void CLAMP_QUICK_NC_DOS_DOT(INT32* S, INT32* T, INT32 maxs, INT32 maxt, int num);

INLINE void CLAMP_C(INT32* S, INT32* T, INT32* SFRAC, INT32* TFRAC, INT32 maxs, INT32 maxt, TILE* tex_tile);
INLINE void CLAMP_LIGHT_C(INT32* S, INT32* T, INT32 maxs, INT32 maxt, TILE* tex_tile);
INLINE void CLAMP_QUICK_C(INT32* S, INT32* T, INT32 maxs, INT32 maxt, int num);

static void (*rdp_clamp_func[8])(INT32*, INT32*, INT32*, INT32*, INT32, INT32, TILE*) =
{
	CLAMP_NC_NDOS_NDOT,		CLAMP_NC_NDOS_DOT,		CLAMP_NC_DOS_NDOT,		CLAMP_NC_DOS_DOT,
	CLAMP_C,				CLAMP_C,				CLAMP_C,				CLAMP_C,
};

static void (*rdp_clamp_light_func[8])(INT32*, INT32*, INT32, INT32, TILE*) =
{
	CLAMP_LIGHT_NC_NDOS_NDOT,	CLAMP_LIGHT_NC_NDOS_DOT,	CLAMP_LIGHT_NC_DOS_NDOT,	CLAMP_LIGHT_NC_DOS_DOT,
	CLAMP_LIGHT_C,				CLAMP_LIGHT_C,				CLAMP_LIGHT_C,				CLAMP_LIGHT_C,
};

static void (*rdp_clamp_quick_func[8])(INT32*, INT32*, INT32, INT32, int) =
{
	CLAMP_QUICK_NC_NDOS_NDOT,	CLAMP_QUICK_NC_NDOS_DOT,	CLAMP_QUICK_NC_DOS_NDOT,	CLAMP_QUICK_NC_DOS_DOT,
	CLAMP_QUICK_C,				CLAMP_QUICK_C,				CLAMP_QUICK_C,				CLAMP_QUICK_C,
};
